echo "#include <boost/utility/result_of.hpp>

template<typename F>
struct function
{
    function()
    {
    }
    
    function(F f_) : f(f_)
    {
    }
    
    template<typename Sig>
    struct result;
    
    template<typename This, typename T0>
    struct result<This(T0)>
      : boost::result_of<F(T0)>::type
    {
    };
    
    template<typename T0>
    typename result<function<F>(T0 const&)>::type
    operator()(T0 const& a0)
    {
        return f(a0);
    }
    
private:
    F f;
};
" > a.cpp

for i in `seq $1`
    do echo "struct f${i}_impl
{
    typedef void result_type;

    template<typename T0>
    result_type operator()(T0 const&) const;
};
static function<f${i}_impl> const f${i};
" >> a.cpp
done
